//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_c "bufio";_aa "bytes";_bc "encoding/hex";_b "errors";_ba "fmt";_dgd "github.com/unidoc/unipdf/v3/common";_dg "github.com/unidoc/unipdf/v3/core";_g "io";_d "os";_eg "regexp";_ef "sort";_e "strconv";_bb "strings";);func (_efa *fdfParser )setFileOffset (_bba int64 ){_efa ._fa .Seek (_bba ,_g .SeekStart );_efa ._ff =_c .NewReader (_efa ._fa );};func (_cba *fdfParser )parseNull ()(_dg .PdfObjectNull ,error ){_ ,_cff :=_cba ._ff .Discard (4);return _dg .PdfObjectNull {},_cff ;};var _ebe =_eg .MustCompile ("\u0025\u0025\u0045O\u0046");var _acag =_eg .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");func (_bdd *fdfParser )readTextLine ()(string ,error ){var _bbc _aa .Buffer ;for {_bge ,_edf :=_bdd ._ff .Peek (1);if _edf !=nil {_dgd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_edf .Error ());return _bbc .String (),_edf ;};if (_bge [0]!='\r')&&(_bge [0]!='\n'){_bgc ,_ :=_bdd ._ff .ReadByte ();_bbc .WriteByte (_bgc );}else {break ;};};return _bbc .String (),nil ;};var _bd =_eg .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_dg .PdfObject ,error ){_cg ,_ga :=fdf .FieldDictionaries ();if _ga !=nil {return nil ,_ga ;};var _efe []string ;for _dge :=range _cg {_efe =append (_efe ,_dge );};_ef .Strings (_efe );_gad :=map[string ]_dg .PdfObject {};for _ ,_cda :=range _efe {_eb :=_cg [_cda ];_cf :=_dg .TraceToDirectObject (_eb .Get ("\u0056"));_gad [_cda ]=_cf ;};return _gad ,nil ;};func (_cfg *fdfParser )parseHexString ()(*_dg .PdfObjectString ,error ){_cfg ._ff .ReadByte ();var _gfce _aa .Buffer ;for {_gg ,_fde :=_cfg ._ff .Peek (1);if _fde !=nil {return _dg .MakeHexString (""),_fde ;};if _gg [0]=='>'{_cfg ._ff .ReadByte ();break ;};_gga ,_ :=_cfg ._ff .ReadByte ();if !_dg .IsWhiteSpace (_gga ){_gfce .WriteByte (_gga );};};if _gfce .Len ()%2==1{_gfce .WriteRune ('0');};_gdd ,_bdg :=_bc .DecodeString (_gfce .String ());if _bdg !=nil {_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_gfce .String ());return _dg .MakeHexString (""),nil ;};return _dg .MakeHexString (string (_gdd )),nil ;};func (_gdg *fdfParser )skipComments ()error {if _ ,_dfc :=_gdg .skipSpaces ();_dfc !=nil {return _dfc ;};_cdd :=true ;for {_gfc ,_dc :=_gdg ._ff .Peek (1);if _dc !=nil {_dgd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_dc .Error ());return _dc ;};if _cdd &&_gfc [0]!='%'{return nil ;};_cdd =false ;if (_gfc [0]!='\r')&&(_gfc [0]!='\n'){_gdg ._ff .ReadByte ();}else {break ;};};return _gdg .skipComments ();};func (_faf *fdfParser )readComment ()(string ,error ){var _ebg _aa .Buffer ;_ ,_cce :=_faf .skipSpaces ();if _cce !=nil {return _ebg .String (),_cce ;};_dca :=true ;for {_cgd ,_dcd :=_faf ._ff .Peek (1);if _dcd !=nil {_dgd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_dcd .Error ());return _ebg .String (),_dcd ;};if _dca &&_cgd [0]!='%'{return _ebg .String (),_b .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");};_dca =false ;if (_cgd [0]!='\r')&&(_cgd [0]!='\n'){_ab ,_ :=_faf ._ff .ReadByte ();_ebg .WriteByte (_ab );}else {break ;};};return _ebg .String (),nil ;};var _cb =_eg .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");var _efea =_eg .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");func (_gade *fdfParser )seekToEOFMarker (_cag int64 )error {_bab :=int64 (0);_cadg :=int64 (1000);for _bab < _cag {if _cag <=(_cadg +_bab ){_cadg =_cag -_bab ;};_ ,_fded :=_gade ._fa .Seek (-_bab -_cadg ,_g .SeekEnd );if _fded !=nil {return _fded ;};_eeb :=make ([]byte ,_cadg );_gade ._fa .Read (_eeb );_dgd .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_eeb ));_babc :=_ebe .FindAllStringIndex (string (_eeb ),-1);if _babc !=nil {_gccb :=_babc [len (_babc )-1];_dgd .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_babc );_gade ._fa .Seek (-_bab -_cadg +int64 (_gccb [0]),_g .SeekEnd );return nil ;};_dgd .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");_bab +=_cadg ;};_dgd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _b .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func (_gd *fdfParser )readAtLeast (_fg []byte ,_bgb int )(int ,error ){_fga :=_bgb ;_ae :=0;_ead :=0;for _fga > 0{_cfd ,_adb :=_gd ._ff .Read (_fg [_ae :]);if _adb !=nil {_dgd .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_cfd ,_ead ,_adb .Error ());return _ae ,_b .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_ead ++;_ae +=_cfd ;_fga -=_cfd ;};return _ae ,nil ;};

// Data represents forms data format (FDF) file data.
type Data struct{_f *_dg .PdfObjectDictionary ;_ag *_dg .PdfObjectArray ;};func (_cbe *fdfParser )parseFdfVersion ()(int ,int ,error ){_cbe ._fa .Seek (0,_g .SeekStart );_gab :=20;_bff :=make ([]byte ,_gab );_cbe ._fa .Read (_bff );_eagab :=_ebc .FindStringSubmatch (string (_bff ));if len (_eagab )< 3{_gbed ,_ffd ,_gbec :=_cbe .seekFdfVersionTopDown ();if _gbec !=nil {_dgd .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");return 0,0,_gbec ;};return _gbed ,_ffd ,nil ;};_da ,_bdf :=_e .Atoi (_eagab [1]);if _bdf !=nil {return 0,0,_bdf ;};_fag ,_bdf :=_e .Atoi (_eagab [2]);if _bdf !=nil {return 0,0,_bdf ;};_dgd .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_da ,_fag );return _da ,_fag ,nil ;};

// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_dg .PdfObjectDictionary ,error ){_ca :=map[string ]*_dg .PdfObjectDictionary {};for _be :=0;_be < fdf ._ag .Len ();_be ++{_bg ,_cd :=_dg .GetDict (fdf ._ag .Get (_be ));if _cd {_fb ,_ :=_dg .GetString (_bg .Get ("\u0054"));if _fb !=nil {_ca [_fb .Str ()]=_bg ;};};};return _ca ,nil ;};func (_eea *fdfParser )parse ()error {_eea ._fa .Seek (0,_g .SeekStart );_eea ._ff =_c .NewReader (_eea ._fa );for {_eea .skipComments ();_ceb ,_ced :=_eea ._ff .Peek (20);if _ced !=nil {_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");return _ced ;};if _bb .HasPrefix (string (_ceb ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_eea ._ff .Discard (7);_eea .skipSpaces ();_eea .skipComments ();_gfdd ,_ :=_eea .parseDict ();_eea ._ee =_gfdd ;break ;};_cecd :=_bd .FindStringSubmatchIndex (string (_ceb ));if len (_cecd )< 6{_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_ceb ));return _b .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_cfad ,_ced :=_eea .parseIndirectObject ();if _ced !=nil {return _ced ;};switch _gcab :=_cfad .(type ){case *_dg .PdfIndirectObject :_eea ._bea [_gcab .ObjectNumber ]=_gcab ;case *_dg .PdfObjectStream :_eea ._bea [_gcab .ObjectNumber ]=_gcab ;default:return _b .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");};};return nil ;};func _bce (_eac string )(*fdfParser ,error ){_aec :=fdfParser {};_fab :=[]byte (_eac );_gfg :=_aa .NewReader (_fab );_aec ._fa =_gfg ;_aec ._bea =map[int64 ]_dg .PdfObject {};_becg :=_c .NewReader (_gfg );_aec ._ff =_becg ;_aec ._ge =int64 (len (_eac ));return &_aec ,_aec .parse ();};func (_dbaf *fdfParser )parseIndirectObject ()(_dg .PdfObject ,error ){_aga :=_dg .PdfIndirectObject {};_dgd .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");_geb ,_bee :=_dbaf ._ff .Peek (20);if _bee !=nil {_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");return &_aga ,_bee ;};_dgd .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_geb ));_gbc :=_bd .FindStringSubmatchIndex (string (_geb ));if len (_gbc )< 6{_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_geb ));return &_aga ,_b .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_dbaf ._ff .Discard (_gbc [0]);_dgd .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_gbc );_agbf :=_gbc [1]-_gbc [0];_cfe :=make ([]byte ,_agbf );_ ,_bee =_dbaf .readAtLeast (_cfe ,_agbf );if _bee !=nil {_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_bee );return nil ,_bee ;};_dgd .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_cfe );_gff :=_bd .FindStringSubmatch (string (_cfe ));if len (_gff )< 3{_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_cfe ));return &_aga ,_b .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");};_cac ,_ :=_e .Atoi (_gff [1]);_ecg ,_ :=_e .Atoi (_gff [2]);_aga .ObjectNumber =int64 (_cac );_aga .GenerationNumber =int64 (_ecg );for {_egf ,_eec :=_dbaf ._ff .Peek (2);if _eec !=nil {return &_aga ,_eec ;};_dgd .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_egf ),string (_egf ));if _dg .IsWhiteSpace (_egf [0]){_dbaf .skipSpaces ();}else if _egf [0]=='%'{_dbaf .skipComments ();}else if (_egf [0]=='<')&&(_egf [1]=='<'){_dgd .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_aga .PdfObject ,_eec =_dbaf .parseDict ();_dgd .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_eec );if _eec !=nil {return &_aga ,_eec ;};_dgd .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");}else if (_egf [0]=='/')||(_egf [0]=='(')||(_egf [0]=='[')||(_egf [0]=='<'){_aga .PdfObject ,_eec =_dbaf .parseObject ();if _eec !=nil {return &_aga ,_eec ;};_dgd .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");}else {if _egf [0]=='e'{_bfe ,_ffa :=_dbaf .readTextLine ();if _ffa !=nil {return nil ,_ffa ;};if len (_bfe )>=6&&_bfe [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _egf [0]=='s'{_egf ,_ =_dbaf ._ff .Peek (10);if string (_egf [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_fdb :=6;if len (_egf )> 6{if _dg .IsWhiteSpace (_egf [_fdb ])&&_egf [_fdb ]!='\r'&&_egf [_fdb ]!='\n'{_dgd .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");_fdb ++;};if _egf [_fdb ]=='\r'{_fdb ++;if _egf [_fdb ]=='\n'{_fdb ++;};}else if _egf [_fdb ]=='\n'{_fdb ++;};};_dbaf ._ff .Discard (_fdb );_cec ,_edb :=_aga .PdfObject .(*_dg .PdfObjectDictionary );if !_edb {return nil ,_b .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");};_dgd .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_cec );_efeb ,_efd :=_cec .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_dg .PdfObjectInteger );if !_efd {return nil ,_b .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");};_acc :=*_efeb ;if _acc < 0{return nil ,_b .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_acc )> _dbaf ._ge {_dgd .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");return nil ,_b .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_fgd :=make ([]byte ,_acc );_ ,_eec =_dbaf .readAtLeast (_fgd ,int (_acc ));if _eec !=nil {_dgd .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_fgd ),_fgd );_dgd .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_eec );return nil ,_eec ;};_ada :=_dg .PdfObjectStream {};_ada .Stream =_fgd ;_ada .PdfObjectDictionary =_aga .PdfObject .(*_dg .PdfObjectDictionary );_ada .ObjectNumber =_aga .ObjectNumber ;_ada .GenerationNumber =_aga .GenerationNumber ;_dbaf .skipSpaces ();_dbaf ._ff .Discard (9);_dbaf .skipSpaces ();return &_ada ,nil ;};};_aga .PdfObject ,_eec =_dbaf .parseObject ();return &_aga ,_eec ;};};_dgd .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");return &_aga ,nil ;};func (_beb *fdfParser )getFileOffset ()int64 {_aaa ,_ :=_beb ._fa .Seek (0,_g .SeekCurrent );_aaa -=int64 (_beb ._ff .Buffered ());return _aaa ;};func (_aae *fdfParser )parseDict ()(*_dg .PdfObjectDictionary ,error ){_dgd .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");_gddg :=_dg .MakeDict ();_gaa ,_ :=_aae ._ff .ReadByte ();if _gaa !='<'{return nil ,_b .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_gaa ,_ =_aae ._ff .ReadByte ();if _gaa !='<'{return nil ,_b .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};for {_aae .skipSpaces ();_aae .skipComments ();_dfe ,_cbg :=_aae ._ff .Peek (2);if _cbg !=nil {return nil ,_cbg ;};_dgd .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_dfe ),string (_dfe ));if (_dfe [0]=='>')&&(_dfe [1]=='>'){_dgd .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_aae ._ff .ReadByte ();_aae ._ff .ReadByte ();break ;};_dgd .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");_cbb ,_cbg :=_aae .parseName ();_dgd .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_cbb );if _cbg !=nil {_dgd .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_cbg );return nil ,_cbg ;};if len (_cbb )> 4&&_cbb [len (_cbb )-4:]=="\u006e\u0075\u006c\u006c"{_fge :=_cbb [0:len (_cbb )-4];_dgd .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_cbb );_dgd .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_fge );_aae .skipSpaces ();_faef ,_ :=_aae ._ff .Peek (1);if _faef [0]=='/'{_gddg .Set (_fge ,_dg .MakeNull ());continue ;};};_aae .skipSpaces ();_agb ,_cbg :=_aae .parseObject ();if _cbg !=nil {return nil ,_cbg ;};_gddg .Set (_cbb ,_agb );_dgd .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_cbb ,_agb .String ());};_dgd .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");return _gddg ,nil ;};func (_faff *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_faff ._fa .Seek (0,_g .SeekStart );_faff ._ff =_c .NewReader (_faff ._fa );_baf :=20;_fdf :=make ([]byte ,_baf );for {_egd ,_gbd :=_faff ._ff .ReadByte ();if _gbd !=nil {if _gbd ==_g .EOF {break ;}else {return 0,0,_gbd ;};};if _dg .IsDecimalDigit (_egd )&&_fdf [_baf -1]=='.'&&_dg .IsDecimalDigit (_fdf [_baf -2])&&_fdf [_baf -3]=='-'&&_fdf [_baf -4]=='F'&&_fdf [_baf -5]=='D'&&_fdf [_baf -6]=='P'{_gdfb :=int (_fdf [_baf -2]-'0');_bddc :=int (_egd -'0');return _gdfb ,_bddc ,nil ;};_fdf =append (_fdf [1:_baf ],_egd );};return 0,0,_b .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_dba *fdfParser )parseObject ()(_dg .PdfObject ,error ){_dgd .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");_dba .skipSpaces ();for {_ggfc ,_efab :=_dba ._ff .Peek (2);if _efab !=nil {return nil ,_efab ;};_dgd .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_ggfc ));if _ggfc [0]=='/'{_bcb ,_gag :=_dba .parseName ();_dgd .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_bcb );return &_bcb ,_gag ;}else if _ggfc [0]=='('{_dgd .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _dba .parseString ();}else if _ggfc [0]=='['{_dgd .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");return _dba .parseArray ();}else if (_ggfc [0]=='<')&&(_ggfc [1]=='<'){_dgd .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _dba .parseDict ();}else if _ggfc [0]=='<'{_dgd .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");return _dba .parseHexString ();}else if _ggfc [0]=='%'{_dba .readComment ();_dba .skipSpaces ();}else {_dgd .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_ggfc ,_ =_dba ._ff .Peek (15);_ccc :=string (_ggfc );_dgd .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_ccc );if (len (_ccc )> 3)&&(_ccc [:4]=="\u006e\u0075\u006c\u006c"){_bgd ,_cgc :=_dba .parseNull ();return &_bgd ,_cgc ;}else if (len (_ccc )> 4)&&(_ccc [:5]=="\u0066\u0061\u006cs\u0065"){_af ,_fgg :=_dba .parseBool ();return &_af ,_fgg ;}else if (len (_ccc )> 3)&&(_ccc [:4]=="\u0074\u0072\u0075\u0065"){_acd ,_acf :=_dba .parseBool ();return &_acd ,_acf ;};_eae :=_acag .FindStringSubmatch (_ccc );if len (_eae )> 1{_ggfc ,_ =_dba ._ff .ReadBytes ('R');_dgd .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_ggfc [:]));_bcbg ,_adc :=_ggf (string (_ggfc ));return &_bcbg ,_adc ;};_fcg :=_efea .FindStringSubmatch (_ccc );if len (_fcg )> 1{_dgd .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _dba .parseNumber ();};_fcg =_cb .FindStringSubmatch (_ccc );if len (_fcg )> 1{_dgd .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");_dgd .Log .Trace ("\u0025\u0020\u0073",_fcg );return _dba .parseNumber ();};_dgd .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_ccc );return nil ,_b .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");};};};

// Load loads FDF form data from `r`.
func Load (r _g .ReadSeeker )(*Data ,error ){_ad ,_gf :=_eeg (r );if _gf !=nil {return nil ,_gf ;};_fc ,_gf :=_ad .Root ();if _gf !=nil {return nil ,_gf ;};_ac ,_df :=_dg .GetArray (_fc .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_df {return nil ,_b .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");};return &Data {_ag :_ac ,_f :_fc },nil ;};func (_aag *fdfParser )skipSpaces ()(int ,error ){_eag :=0;for {_dgda ,_ed :=_aag ._ff .ReadByte ();if _ed !=nil {return 0,_ed ;};if _dg .IsWhiteSpace (_dgda ){_eag ++;}else {_aag ._ff .UnreadByte ();break ;};};return _eag ,nil ;};

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_dga ,_gfd :=_d .Open (fdfPath );if _gfd !=nil {return nil ,_gfd ;};defer _dga .Close ();return Load (_dga );};func (_gcc *fdfParser )parseNumber ()(_dg .PdfObject ,error ){return _dg .ParseNumber (_gcc ._ff )};func (_ce *fdfParser )parseArray ()(*_dg .PdfObjectArray ,error ){_cgb :=_dg .MakeArray ();_ce ._ff .ReadByte ();for {_ce .skipSpaces ();_deg ,_fae :=_ce ._ff .Peek (1);if _fae !=nil {return _cgb ,_fae ;};if _deg [0]==']'{_ce ._ff .ReadByte ();break ;};_bfc ,_fae :=_ce .parseObject ();if _fae !=nil {return _cgb ,_fae ;};_cgb .Append (_bfc );};return _cgb ,nil ;};func (_ccd *fdfParser )parseBool ()(_dg .PdfObjectBool ,error ){_eee ,_gb :=_ccd ._ff .Peek (4);if _gb !=nil {return _dg .PdfObjectBool (false ),_gb ;};if (len (_eee )>=4)&&(string (_eee [:4])=="\u0074\u0072\u0075\u0065"){_ccd ._ff .Discard (4);return _dg .PdfObjectBool (true ),nil ;};_eee ,_gb =_ccd ._ff .Peek (5);if _gb !=nil {return _dg .PdfObjectBool (false ),_gb ;};if (len (_eee )>=5)&&(string (_eee [:5])=="\u0066\u0061\u006cs\u0065"){_ccd ._ff .Discard (5);return _dg .PdfObjectBool (false ),nil ;};return _dg .PdfObjectBool (false ),_b .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func _ggf (_gcg string )(_dg .PdfObjectReference ,error ){_gdc :=_dg .PdfObjectReference {};_cada :=_acag .FindStringSubmatch (_gcg );if len (_cada )< 3{_dgd .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");return _gdc ,_b .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");};_gbf ,_dgg :=_e .Atoi (_cada [1]);if _dgg !=nil {_dgd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_cada [1]);return _gdc ,nil ;};_gdc .ObjectNumber =int64 (_gbf );_gfa ,_dgg :=_e .Atoi (_cada [2]);if _dgg !=nil {_dgd .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_cada [2]);return _gdc ,nil ;};_gdc .GenerationNumber =int64 (_gfa );return _gdc ,nil ;};func _eeg (_dac _g .ReadSeeker )(*fdfParser ,error ){_dace :=&fdfParser {};_dace ._fa =_dac ;_dace ._bea =map[int64 ]_dg .PdfObject {};_ggfcf ,_dfee ,_aeb :=_dace .parseFdfVersion ();if _aeb !=nil {_dgd .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_aeb );return nil ,_aeb ;};_dace ._cc =_ggfcf ;_dace ._cfa =_dfee ;_aeb =_dace .parse ();return _dace ,_aeb ;};func (_cad *fdfParser )parseString ()(*_dg .PdfObjectString ,error ){_cad ._ff .ReadByte ();var _eaga _aa .Buffer ;_cddb :=1;for {_bbfe ,_cfc :=_cad ._ff .Peek (1);if _cfc !=nil {return _dg .MakeString (_eaga .String ()),_cfc ;};if _bbfe [0]=='\\'{_cad ._ff .ReadByte ();_gca ,_dbb :=_cad ._ff .ReadByte ();if _dbb !=nil {return _dg .MakeString (_eaga .String ()),_dbb ;};if _dg .IsOctalDigit (_gca ){_bef ,_adf :=_cad ._ff .Peek (2);if _adf !=nil {return _dg .MakeString (_eaga .String ()),_adf ;};var _bf []byte ;_bf =append (_bf ,_gca );for _ ,_de :=range _bef {if _dg .IsOctalDigit (_de ){_bf =append (_bf ,_de );}else {break ;};};_cad ._ff .Discard (len (_bf )-1);_dgd .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_bf );_aba ,_adf :=_e .ParseUint (string (_bf ),8,32);if _adf !=nil {return _dg .MakeString (_eaga .String ()),_adf ;};_eaga .WriteByte (byte (_aba ));continue ;};switch _gca {case 'n':_eaga .WriteRune ('\n');case 'r':_eaga .WriteRune ('\r');case 't':_eaga .WriteRune ('\t');case 'b':_eaga .WriteRune ('\b');case 'f':_eaga .WriteRune ('\f');case '(':_eaga .WriteRune ('(');case ')':_eaga .WriteRune (')');case '\\':_eaga .WriteRune ('\\');};continue ;}else if _bbfe [0]=='('{_cddb ++;}else if _bbfe [0]==')'{_cddb --;if _cddb ==0{_cad ._ff .ReadByte ();break ;};};_geg ,_ :=_cad ._ff .ReadByte ();_eaga .WriteByte (_geg );};return _dg .MakeString (_eaga .String ()),nil ;};func (_fbc *fdfParser )trace (_ecgc _dg .PdfObject )_dg .PdfObject {switch _gega :=_ecgc .(type ){case *_dg .PdfObjectReference :_dbf ,_gdgg :=_fbc ._bea [_gega .ObjectNumber ].(*_dg .PdfIndirectObject );if _gdgg {return _dbf .PdfObject ;};_dgd .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_dg .PdfIndirectObject :return _gega .PdfObject ;};return _ecgc ;};

// Root returns the Root of the FDF document.
func (_bgg *fdfParser )Root ()(*_dg .PdfObjectDictionary ,error ){if _bgg ._ee !=nil {if _ged ,_eef :=_bgg .trace (_bgg ._ee .Get ("\u0052\u006f\u006f\u0074")).(*_dg .PdfObjectDictionary );_eef {if _fce ,_gcb :=_bgg .trace (_ged .Get ("\u0046\u0044\u0046")).(*_dg .PdfObjectDictionary );_gcb {return _fce ,nil ;};};};var _dfb []int64 ;for _aaf :=range _bgg ._bea {_dfb =append (_dfb ,_aaf );};_ef .Slice (_dfb ,func (_fbd ,_bcbgb int )bool {return _dfb [_fbd ]< _dfb [_bcbgb ]});for _ ,_gbfa :=range _dfb {_bcc :=_bgg ._bea [_gbfa ];if _eca ,_bfb :=_bgg .trace (_bcc ).(*_dg .PdfObjectDictionary );_bfb {if _gdce ,_ebb :=_bgg .trace (_eca .Get ("\u0046\u0044\u0046")).(*_dg .PdfObjectDictionary );_ebb {return _gdce ,nil ;};};};return nil ,_b .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};var _ebc =_eg .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");type fdfParser struct{_cc int ;_cfa int ;_bea map[int64 ]_dg .PdfObject ;_fa _g .ReadSeeker ;_ff *_c .Reader ;_ge int64 ;_ee *_dg .PdfObjectDictionary ;};func (_gec *fdfParser )parseName ()(_dg .PdfObjectName ,error ){var _gc _aa .Buffer ;_acb :=false ;for {_db ,_fd :=_gec ._ff .Peek (1);if _fd ==_g .EOF {break ;};if _fd !=nil {return _dg .PdfObjectName (_gc .String ()),_fd ;};if !_acb {if _db [0]=='/'{_acb =true ;_gec ._ff .ReadByte ();}else if _db [0]=='%'{_gec .readComment ();_gec .skipSpaces ();}else {_dgd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_db ,_db );return _dg .PdfObjectName (_gc .String ()),_ba .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_db [0]);};}else {if _dg .IsWhiteSpace (_db [0]){break ;}else if (_db [0]=='/')||(_db [0]=='[')||(_db [0]=='(')||(_db [0]==']')||(_db [0]=='<')||(_db [0]=='>'){break ;}else if _db [0]=='#'{_ebf ,_gdf :=_gec ._ff .Peek (3);if _gdf !=nil {return _dg .PdfObjectName (_gc .String ()),_gdf ;};_gec ._ff .Discard (3);_acg ,_gdf :=_bc .DecodeString (string (_ebf [1:3]));if _gdf !=nil {return _dg .PdfObjectName (_gc .String ()),_gdf ;};_gc .Write (_acg );}else {_abf ,_ :=_gec ._ff .ReadByte ();_gc .WriteByte (_abf );};};};return _dg .PdfObjectName (_gc .String ()),nil ;};